version: "3.8"

networks:
  internal:
    driver: overlay
    attachable: true
  traefik-public:
    external: true
    
services:
  workspace:
    #image: bencdr/code-server-deploy-container
    #image: codercom/code-server:3.9.3
    image: registry.gitlab.com/devs.cordeiro/vsc-mysql-php:latest
    #image: gitpod/workspace-mysql
    #command: sleep infinity
    deploy:
      replicas: 1
      restart_policy:
        condition: any
        delay: 10s
        max_attempts: 10
        window: 15s
      labels:
        - traefik.enable=true
        - traefik.docker.network=traefik-public
        - traefik.constraint-label=traefik-public
        - traefik.http.routers.vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.rule=Host(`vsc.${GITLAB_USER_ID}.${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${DOMAIN}`)
        - traefik.http.routers.vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.entrypoints=http
        - traefik.http.routers.vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.service=vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
        - traefik.http.routers.vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.middlewares=https-redirect
        - traefik.http.routers.vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.rule=Host(`vsc.${GITLAB_USER_ID}.${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${DOMAIN}`)
        - traefik.http.routers.vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.entrypoints=https
        - traefik.http.routers.vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.service=vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
        - traefik.http.routers.vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.tls=true
        - traefik.http.routers.vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.tls.certresolver=le
        - traefik.http.services.vsc-${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}.loadbalancer.server.port=8080

        - traefik.http.routers.${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.rule=Host(`${GITLAB_USER_ID}.${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${DOMAIN}`)
        - traefik.http.routers.${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.entrypoints=http
        - traefik.http.routers.${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.service=${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
        - traefik.http.routers.${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.middlewares=https-redirect
        - traefik.http.routers.${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.rule=Host(`${GITLAB_USER_ID}.${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${DOMAIN}`)
        - traefik.http.routers.${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.entrypoints=https
        - traefik.http.routers.${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.service=${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
        - traefik.http.routers.${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.tls=true
        - traefik.http.routers.${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.tls.certresolver=le
        - traefik.http.services.${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}.loadbalancer.server.port=8000
    environment:
      - HASHED_PASSWORD=dedafc68da3f3de7cefefa59820db80a235d15636ee294d3903498cc01b9b035
      - GIT_REPO=${CI_PROJECT_URL}
      - START_DIR=/workspace/${CI_PROJECT_NAME}
    networks:
      - traefik-public
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
